'From Smalltalk-80, Version 2.4 of 28 January 1989 on 14 March 1989 at 3:34:11 pm'!

TtyConnection subclass: #MidiPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Music-Voices'!
MidiPort comment:
'An Instance of MidiPort exists for each physical Midi cable and is the output driver for the Midi commands sent by MidiDevices.

A MidiDevice points to a MidiPort and sends it time-stamped byteArrays.
The MidiPort uses the ExternalPort I/O primitives for byteArray input/output'!


!MidiPort methodsFor: 'private'!

reopen
	"no-op for now"
"
	self setMidiMode.
	super reopen
"! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MidiPort class
	instanceVariableNames: ''!


!MidiPort class methodsFor: 'maintenance'!

flush
	"release and close all of my instances"
	"MidiPort flush"

	MidiPort allInstances do: [ :aMP |
		aMP close.
		Smalltalk removeDependent: aMP.
		aMP release
	]! !