'From Smalltalk-80, Version 2.3 of 13 June 1988 on 5 September 1988 at 2:06:43 pm'!



!Form class methodsFor: 'special'!

displayInView
	"display all defined cursor constants in a pretty square"
	"Form displayInView."

	| aFHView aFHController aColl aNum col lin theForm ePos cPos iPos lPos cnt aStr step aSSView cArray|

	step _ 100.
	aColl _ FormConstants associations.		"get ordered collection of Forms"
	aNum _ aColl size.						"count 'em"
	cArray _ Array new: aNum.
	col _ (aNum sqrt + 1) asInteger.		"basic display = square"
	lin _ aNum // col.
	col * lin < aNum ifTrue: [				"can't i avoid this? (i.e., aNum = 70 or 75, col=9..)"
		lin _ lin + 1 ].
	ePos _ ((col * step) + 16) @ ((lin * step) + 16).		"display extent"
	cPos _ 16 @ 8.							"starting pos"
	iPos _ step@0.							"increment pos"
	lPos _ ((col - 1) * (step negated)) @ (step).			"line increment pos"
	theForm _ Form extent: ePos.			"set up form area"
	cnt _ 1.
	aColl do: [ :each | 						"loop through all instances"
		cArray at: cnt put: each value.
		each value displayOn: theForm at: (cPos - each value offset).		"display cursor"
		aStr _ each key asString.					"get name"
		(aStr asDisplayText) displayOn: theForm at: (cPos + (-8@(each value extent y + 2))).
		cnt _ cnt + 1.						"update count and position"
		(cnt \\ col = 1) ifTrue: 				"if end of line.."
			[cPos _ cPos + lPos ]
		ifFalse: 
			[cPos _ cPos + iPos ]
	].											"end of select for all cursors"
	aFHView _ FormHolderView new model: theForm.
	aFHController _ FormHitController new 
		grid: (step @ step); 
		size: col@lin; 
		array: cArray.
	aFHView controller: aFHController.
	aSSView _ StandardSystemView new.
	aSSView addSubView: aFHView.
	aSSView label: 'Forms'.
	aSSView borderWidth: 2.
	aSSView minimumSize: ePos; maximumSize: ePos.
	aSSView controller open.! !