'From Smalltalk-80, Version 2.4 of 21 July 1988 on 27 July 1988 at 7:46:49 am'!

!ScreenController methodsFor: 'menu messages'!

openSystemOutline
	"open a system outliner"

	OutlineBrowser openWithButtonsOn: SystemOutline label: 'System Outline'.!

openEventListDictionaryInspector
	"Open an inspector on the EventList dictionary."

	EventListDictionaryInspectorView openWithButtons: 
		(EventListDictionaryInspector inspect: EventLists)!

openEventListEditor
	"Open your favorite EventListEditor--put your standard version in here."

	ThreePartHSEventListView openWith8ButtonsAndHAndVScrollingOn: EventListEditor defaultEventList! !


!ScreenController class methodsFor: 'class initialization'!
initializeHSTK
	"Initialize the System Menu for HSTK V5.0."
	"ScreenController initializeHSTK.
	ScreenController allInstancesDo: [:c | c initializeYellowButtonMenu]"

	ScreenYellowButtonMenu _
		PopUpMenu
			labels: 
'restore display
garbage collect
exit project
browser
workspace
file list
file editor
terminal
project
eventList editor
eventList dictionary
system transcript
system outline
suspend
save
quit'
			lines: #(3 9 11 13).
	ScreenYellowButtonMessages _
			#(restoreDisplay garbageCollect exitProject
			openBrowser openWorkspace openFileList openFileEditor openTerminalView openProject 
			openEventListEditor openEventListDictionaryInspector
			openTranscript openSystemOutline
			openDeskTop save quit).! !

ScreenController initializeHSTK.
	ScreenController allInstancesDo: [:c | c initializeYellowButtonMenu]!
