'From Smalltalk-80, Version 2.3 of 13 June 1988 on 3 April 1989 at 7:51:52 am'!

!Peal class methodsFor: 'instance creation'!
peal: group tempo: anInt
	"play a simple repetitive bell peal"
	"Peal peal: #(82 79 77 74 72) tempo: 200"

	(Peal upon: group) 
			playOn: Midi 
			durations: anInt * 2 
			meter: anInt 
			at: Time millisecondClockValue!

peal: group1 tempo: anInt1 and: group2 tempo: anInt2
	"play a simple repetitive bell peal"
	"Peal peal: #(82 79 77 74 72) tempo: 700
		and: #(50 47 45 43) tempo: 90."

	| m p1 p2 t |
	t _ Time millisecondClockValue.
	m _ Midi.
	p1 _ Peal upon: group1.
	p2 _ Peal upon: group2.
	p2 playOn: m durations: anInt1 * 2 meter: anInt1 at: t+2000.
	p1 playOn: m durations: anInt2 * 2 meter: anInt2 at: t+100!

peal: group tempo: anInt at: startTime
	"play a simple repetitive bell peal"
	"Peal peal: #(82 79 77 74 72) tempo: 200 
		at: (Time millisecondClockValue + 2000)"

	(Peal upon: group) 
			playOn: Midi 
			durations: anInt * 2 
			meter: anInt 
			at: startTime! !

!Peal class methodsFor: 'examples'!
exampleRand
	"Play a two-tier peal with different tempi"
	"Peal exampleRand"

	| rand pBase pArray1 pArray2 tempo1 tempo2 score |
	rand _ Random new.
	pBase _ 24 + (rand next * 48) rounded.
	pArray1 _ Array new: 2 + ((rand next * 2) rounded).
	1 to: pArray1 size do: 
		[:ind | pArray1 at: ind put: (pBase + (rand  next * 8) rounded)].
	pBase _ 48 + (rand next * 48) rounded.
	pArray2 _ Array new: 2 + ((rand next * 3) rounded).
	1 to: pArray2 size do: 
		[:ind | pArray2 at: ind put: (pBase + (rand  next * 6) rounded)].
	tempo1 _ 120 + (rand next * 60) rounded. "slow"
	tempo2 _ 20 + (rand next * 20) rounded. "fast"
	Transcript show: 'Peal: ', pArray1 printString; tab; show: tempo1 printString; cr; 
			show: pArray2 printString; tab; show: tempo2 printString; cr; cr.
	Peal peal: pArray1 tempo: tempo1
		and: pArray2 tempo: tempo2.
	(Delay forMilliseconds: ((tempo1 max: tempo2) * (pArray1 size max: pArray2 size) 
		* (pArray1 size max: pArray2 size) * (pArray1 size max: pArray2 size))) wait!

pealExample1
	"Play a two-tier peal with different tempi"
	"Peal pealExample1"

	Peal peal: #(82 79 77 82) tempo: 500
		and: #(47 45 43) tempo: 90! !

!Arpeggio methodsFor: 'playing'!
edit
	"edit me"

	HSEventListView openWith8ButtonsAndHAndVScrollingOn: self! !

OutlineBrowser class removeSelector: #openWithButtonsOn1:label:!
