#	File UserPrim.make -  Make User Primitives examples.
#
#	Copyright ParcPlace Systems, Inc. 1988
#	All rights reserved.
#
#	This makefile builds:
#		The Smalltalk Virtual Machine: with user defined primitives
#										for MPW C
#	The Smalltalk Virtual Machine has a SIZE resource #128
#	which allows the user to set the size of the heap zone
#	for user primitives.  It is currently set to 96K, you
#	may have to change this value to accomodate your routines.
#	This change is most easily accomplished with resEdit.
#
Libs = 		"{CLibraries}"CRuntime.o 
			"{Libraries}"Interface.o 
			"{CLibraries}"CInterface.o 
			"{CLibraries}"CSANELib.o 
			"{CLibraries}"StdCLib.o
COptions =	

midi		MIDI1

		
MIDI1		MidiPrimitives.c.o 
				driverInterface.c.o 
				Smalltalk.lib
				link -w -c PSS3 MidiPrimitives.c.o
					driverInterface.c.o
					Smalltalk.lib
					{Libs} 
					-o Smalltalk-MIDI
				duplicate -y MidiPrimitives.c.o MidiPrimitives
				
MidiPrimitives.c.o					MidiPrimitives.c UserPrim.h midi.h
	C -DMAC MidiPrimitives.c -o MidiPrimitives.c.o
driverInterface.c.o				driverInterface.c midi.h
	C -DMAC driverInterface.c -o driverInterface.c.o
